var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    initialiseDrawingParams();
    HideControls();
}
      
function initialiseEvents(){
    /*$($(document)).on("input","#crypto", function(){
        drawBasicScreen();
    });*/

    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
    
    $("[type='number']").keypress(function (evt) {
        evt.preventDefault();
    });
} 

function initialiseGUI(){

}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
}

function drawBasicScreen(){
    //Φόντα οθόνης
    if(!(IntroStep>IntroLastImageStep && mouseMoving)){
        cntx.clearRect(0,0,canvas.width,canvas.height);
        drawIntroImage();
    }
    if(IntroStep>IntroLastImageStep){
        if(!mouseMoving){
            $("#controlsDiv").show();
            cntx.strokeStyle="red";
            var Xinit=appletWidth/2;
            var Yinit=BottomPanelTop;
            useColors=$("#colorise").prop("checked");
            DrawExample();
        }
    }
    else{
        $("#controlsDiv").hide();
    }
    cntx.clearRect(0,0,canvas.width,TopPanelHeight);
    cntx.clearRect(0,BottomPanelTop,canvas.width,BottomPanelHeight);
    drawBorders();
    drawLogoImage();
    if(IntroStep<IntroLastStep)drawButtonNext();
    if(IntroStep>1)drawButtonBack();
    if(!mouseMoving && $("#chkShowCode").prop("checked"))DrawProgram();
    showUserPrompts();
}

function drawIntroImage(){
    if(IntroStep<=IntroLastImageStep){
        Intro=document.getElementById("img"+IntroStep);
        picTop=(height-Intro.height)/2;
        cntx.drawImage(Intro,1,picTop);
    }
    else{
        cntx.fillStyle="white";
        cntx.fillRect(1,TopPanelHeight,appletWidth,BottomPanelTop-TopPanelHeight);
    }
}

function drawBorders(){
    cntx.strokeStyle="black";
    cntx.beginPath();
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
    mouseMoving=false;
}

function handleMouseMove(){
    mouseMoving=true;
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    if(mx>=330 && mx<=354 && my>=550 && my<=560 && IntroStep<Tree2){
        canvas.style.cursor="pointer";
    }
    else{
        canvas.style.cursor="default";
    }
    
    drawBasicScreen();
    if(debug) console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    else{
        if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && IntroStep<IntroLastStep) {
            IntroStep++;
            HideControls();
        }
        else if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && IntroStep>1) {
            IntroStep--;
            HideControls();
        }
        else if(mx>=330 && mx<=354 && my>=550 && my<=560 && IntroStep<Tree2){
            IntroStep=Tree2;
            HideControls();
        }
        mouseMoving=false;
        drawBasicScreen();
    }
}

function showUserPrompts(){
    var vTxtOffset=15;
    var hTxtOffset=BackStepLeft+BackStepWidth+Border;
    var promptYCoord;
    if(IntroStep<Tree2){
        promptYCoord=BottomPanelTop+40;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Αν θες να προσπεράσεις την εισαγωγή κάνε κλικ ΕΔΩ.");
    }
    else if(IntroStep==Tree1){
        promptYCoord=BottomPanelTop+40;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Μπορείς να αυξήσεις την πιθανότητα διακλάδωσης με τη μπάρα κύλισης. Ποια τιμή δίνει καλύτερα αποτέλεσματα;");
        promptYCoord=promptYCoord+15;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Χρησιμοποίησε το διακόπτη [Χρωματισμός] για πιο ρεαλιστικό αποτέλεσμα.");
        promptYCoord=promptYCoord+15;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Με το κουμπί [Νέο Σχέδιο] μπορείς να παράγεις διαφορετικά δέντρα κατά τρόπο τυχαίο.");
    }
    else if(IntroStep==Tree2){
        promptYCoord=BottomPanelTop+40;
        cnvsWrite(LetterColor,fontSize-1,"Arial",370,promptYCoord,"Πειραματίσου με τις παραμέτρους");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize-1,"Arial",370,promptYCoord,"και προσπάθησε να καταλάβεις τη λειτουργία τους.");
    }
    else if(IntroStep==Tree3){
        promptYCoord=BottomPanelTop+40;
        cnvsWrite(LetterColor,fontSize-1,"Arial",370,promptYCoord,"Στην επόμενη οθόνη θα φτιάξουμε ολόκληρο δάσος!");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize-1,"Arial",370,promptYCoord,"(Μακάρι να ήταν τόσο εύκολο και στην πραγματικότητα)");
    }
    else if(IntroStep==Forest){
        promptYCoord=BottomPanelTop+40;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Τα παραδείγματα που ακολουθούν στις επόμενες σελίδες έχουν σχέση με τα Μαθηματικά.");
        promptYCoord=promptYCoord+15;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Προσπάθησε να καταλάβεις τη σημασία των παραμέτρων και τη λογική του αντίστοιχου αλγόριθμου.");
        promptYCoord=promptYCoord+15;
        cnvsWrite(LetterColor,fontSize-1,"Arial",hTxtOffset,promptYCoord,"Η εντολή που λειτουργεί Αναδρομικά εμφανίζεται με πράσινο χρώμα.");
    }
    else if(IntroStep==Triangle){
        if($("#chkShowCode").prop("checked")){
            promptYCoord=BottomPanelTop+40;
            cnvsWrite(LetterColor,fontSize-1,"Arial",200,promptYCoord,"Έστω ότι κάθε τρίγωνο ορίζεται από τα αντίστοιχα σημεία Α, Β, Γ.");
            promptYCoord=promptYCoord+15;
            cnvsWrite(LetterColor,fontSize-1,"Arial",200,promptYCoord,"Μπορείς να αναζητήσεις στο διαδίκτυο πληροφορίες για το όνομα Sierpinski.");
            promptYCoord=promptYCoord+15;
            cnvsWrite(LetterColor,fontSize-1,"Arial",40,promptYCoord,"Ό γεωμετρικός υπολογισμός των σημείων κάθε τριγώνου είναι περίπλοκος.Το επόμενο παράδειγμα είναι πιο απλό.");
        }
    }
    else if(IntroStep==Square){
        if($("#showCode").prop("checked")){
            promptYCoord=BottomPanelTop+60;
            cnvsWrite(LetterColor,fontSize-1,"Arial",200,promptYCoord,"Προσπάθησε να καταλάβεις γιατί η Αναδρομική εντολή καλείται 8 φορές.");
        }
    }
    else if(IntroStep==Circles){
        if($("#showCode").prop("checked")){
            promptYCoord=BottomPanelTop+40;
            cnvsWrite(LetterColor,fontSize-1,"Arial",200,promptYCoord,"Όταν η παράμετρος Εναλλαγή έχει τιμή 0 σχεδιάζεται κόκκινος κύκλος,");
            promptYCoord=promptYCoord+15;
            cnvsWrite(LetterColor,fontSize-1,"Arial",200,promptYCoord,"ενώ όταν είναι 1 σχεδιάζεται λευκός.");
            promptYCoord=promptYCoord+15;
            cnvsWrite(LetterColor,fontSize-1,"Arial",200,promptYCoord,"Τι αποτέλεσμα έχει η εντολή     Εναλλαγή = 1 - Εναλλαγή ;");
        }
    }
}

function DrawTree1(Selector,Xinit,Yinit,Angle,Counter){     
    var BasicSize=10;
    var X1,Y1,X2,Y2,X3,Y3,X4,Y4;
    var XX1,YY1,XX2,YY2,XX3,YY3,XX4,YY4;
    var P;
    if(Selector==0){
      X1=0;
      Y1=0;
      X2=X1;
      Y2=Y1-BasicSize;
      X3=X1-BasicSize;
      Y3=Y2-BasicSize;
      X4=X1+BasicSize;
      Y4=Y2-BasicSize;
      
      XX1=Rotate(X1,Y1,Angle,1);
      YY1=Rotate(X1,Y1,Angle,2);

      XX2=Rotate(X2,Y2,Angle,1);
      YY2=Rotate(X2,Y2,Angle,2);
      
      XX3=Rotate(X3,Y3,Angle,1);
      YY3=Rotate(X3,Y3,Angle,2);

      XX4=Rotate(X4,Y4,Angle,1);
      YY4=Rotate(X4,Y4,Angle,2);

      if(useColors) cntx.strokeStyle=WoodColor;
      cntx.beginPath();
      cntx.moveTo(XX1+Xinit,YY1+Yinit);
      cntx.lineTo(XX2+Xinit,YY2+Yinit);
      cntx.moveTo(XX2+Xinit,YY2+Yinit);
      cntx.lineTo(XX3+Xinit,YY3+Yinit);
      cntx.moveTo(XX2+Xinit,YY2+Yinit);
      cntx.lineTo(XX4+Xinit,YY4+Yinit);
      cntx.stroke();
    
      P=Math.random();
      if(P>1.0-probabilty && Counter<10){
        DrawTree1(0,XX3+Xinit,YY3+Yinit,Angle-Math.PI/12,Counter+1);            
      }
      else if(ComplexTree1 && P>(2-probabilty)/2) {
        DrawTree1(2,XX3+Xinit,YY3+Yinit,Angle-Math.PI/8,Counter+1);
      }
      else{
        DrawTree1(1,XX3+Xinit,YY3+Yinit,Angle-Math.PI/8,Counter+1);
      }
    
      P=Math.random();
      if(P>1-probabilty){
        DrawTree1(0,XX4+Xinit,YY4+Yinit,Angle+Math.PI/12,Counter+1);            
      }
      else if(ComplexTree1 && P>(probabilty)/2){
        DrawTree1(2,XX4+Xinit,YY4+Yinit,Angle+Math.PI/8,Counter+1);
      }
      else{
        DrawTree1(1,XX4+Xinit,YY4+Yinit,Angle+Math.PI/8,Counter+1);
      }
    }
    else if(Selector==1){
      if(useColors) cntx.strokeStyle=LeavesColor;
      X1=0;
      Y1=-BasicSize/2;
      XX1=Rotate(X1,Y1,Angle,1);
      YY1=Rotate(X1,Y1,Angle,2);
      cntx.beginPath();
      cntx.arc(XX1+Xinit,Y1+Yinit,BasicSize,0,2*Math.PI);
      cntx.stroke(); 
    }
    else if(Selector==2){
      if(useColors) cntx.strokeStyle=LeavesColor;
      X1=-BasicSize/2;
      Y1=0;
      X2=BasicSize/2;
      Y2=0;
      X3=0;
      Y3=-BasicSize;
      
      XX1=Rotate(X1,Y1,Angle,1);
      YY1=Rotate(X1,Y1,Angle,2);
      
      XX2=Rotate(X2,Y2,Angle,1);
      YY2=Rotate(X2,Y2,Angle,2);

      XX3=Rotate(X3,Y3,Angle,1);
      YY3=Rotate(X3,Y3,Angle,2);
      
      cntx.beginPath();
      cntx.moveTo(XX1+Xinit,YY1+Yinit);
      cntx.lineTo(XX2+Xinit,YY2+Yinit);
      cntx.moveTo(XX1+Xinit,YY1+Yinit);
      cntx.lineTo(XX3+Xinit,YY3+Yinit);
      cntx.moveTo(XX2+Xinit,YY2+Yinit);
      cntx.lineTo(XX3+Xinit,YY3+Yinit);
      cntx.stroke();
    }
 }
 
function Rotate(x1,y1,Angle,ResultSelector){
  var X2,Y2;
  if(ResultSelector==1){
    X2=parseInt(x1*Math.cos(Angle)-y1*Math.sin(Angle));
    return X2;
  }
  else{
    Y2=parseInt(x1*Math.sin(Angle)+y1*Math.cos(Angle));
    return Y2;
  }
}

function initialiseDrawingParams(){
    mouseMoving=false;
    $("#probability").val(10);
    changeProbabilty();
    drawBasicScreen();
}

function changeProbabilty(){
    mouseMoving=false;
    probabilty=parseFloat($("#probability").val())/100.0;
}

function DrawExample(){
	var Xinit,Yinit;
	if(IntroStep==Tree1){
		cntx.strokeStyle="rgb(255,0,0)";
	    Xinit=appletWidth/2;
	    Yinit=BottomPanelTop;
	    DrawTree1(0,Xinit,Yinit,0,0);
	}
	else if(IntroStep==Tree2){
	    Xinit=appletWidth/2;
	    Yinit=BottomPanelTop;
	    cntx.strokeStyle="rgb(255,0,0)";
	    DrawTree2(Xinit,Yinit,parseInt($("#HscrLength").val()),parseInt($("#HscrDirection").val())*Math.PI/180,0);

	}
	else if(IntroStep==Tree3){
		cntx.strokeStyle="rgb(255,0,0)";
		DrawTree3(parseInt($("#HscrMinimumLength").val()) , 0.5 , 0 , parseInt($("#HscrDirection").val())*Math.PI/180 , parseInt($("#HscrLength").val()));

	}
	else if(IntroStep==Forest){
		$("#colorise").prop("checked",true);
		for(var i=0;i<NoOfTrees;i++){
		    Xinit=parseInt(appletWidth*Math.random());
		    if(Math.random()>0.3){
		    	Yinit=parseInt(2*(BottomPanelTop-TopPanelHeight)*Math.random()/3+TopPanelHeight);
		    }
		    else {			    
		    	Yinit=parseInt((BottomPanelTop-TopPanelHeight)*Math.random()+TopPanelHeight);
		    }
		    DrawTree2(Xinit,Yinit,parseInt($("#HscrLength").val())*2*Yinit/appletHeight,(parseInt($("#HscrDirection").val())+(Math.random()-0.5)*20)*Math.PI/180,i);
		}
	}
	else if(IntroStep==Triangle){
		var TriangleSize=parseInt($("#HscrParameter1").val())*100;
		var x=[0,0,0],y=[0,0,0];
		x[0]=2*appletWidth/3;
		y[0]=TopPanelHeight+Border;
		x[1]=parseInt(x[0]-TriangleSize*Math.cos(Math.PI/3));
		y[1]=parseInt(y[0]+TriangleSize*Math.sin(Math.PI/3));
		x[2]=parseInt(x[0]+TriangleSize*Math.cos(Math.PI/3));
		y[2]=y[1];
		cntx.fillStyle="rgb(255,0,0)";
		cntx.beginPath();
		cntx.moveTo(x[2],y[2]);
		for(i=0;i<3;i++){
		    cntx.lineTo(x[i],y[i]);
		}
		cntx.closePath();
		cntx.fill();
		
		cntx.fillStyle="rgb(255,255,255)";
		DrawSierpinski(TriangleSize,x,y);
	}
	else if(IntroStep==Square){
		var Side=parseInt($("#HscrParameter1").val())*100;
		var initX=400,initY=TopPanelHeight+20;
		cntx.fillStyle="rgb(255,0,0)";
		cntx.fillRect(initX,initY,Side,Side);
		cntx.fillStyle="rgb(255,255,255)";

		DrawGasket(initX,initY,Side);
	}
	else if(IntroStep==Circles){
		var Radius,Xc,Yc;
		Radius=parseInt($("#HscrParameter1").val())*10;
		Xc=4*appletWidth/5-50;
		Yc=appletHeight/2;
		cntx.fillStyle="rgb(255,0,0)";
		RecursiveCircles(Radius,Xc,Yc,0);
	}
}

function DrawTree2(x0,y0,Length,Angle,ii){
	var x1,y1;
	var hscrMinimumLength=parseInt($("#HscrMinimumLength").val());
	if(Length>=hscrMinimumLength) {       
		x1=parseInt(x0+Length*Math.cos(Angle));
		y1=parseInt(y0-Length*Math.sin(Angle));
		if($("#colorise").prop("checked")){
			if(Length>parseInt($("#HscrMinimumLength").val())+1){
				cntx.strokeStyle=WoodColor;
			}
			else{
				cntx.strokeStyle=LeavesColor;
			}
		}
		cntx.beginPath();
		cntx.moveTo(x0,y0);
		cntx.lineTo(x1,y1);
		cntx.stroke();
		if(IntroStep==Tree2){
			DrawTree2(x1,y1,Length*0.75,Angle+parseInt($("#HscrParameter2").val())*Math.PI/180,ii);    		
			DrawTree2(x1,y1,Length*0.66,Angle-parseInt($("#HscrParameter1").val())*Math.PI/180,ii);
		}
		else if(IntroStep==Forest){
			DrawTree2(x1,y1,Length*0.75,Angle+ii*parseInt($("#HscrParameter2").val())*Math.PI/180/NoOfTrees,ii);    		
			DrawTree2(x1,y1,Length*0.66,Angle-ii*parseInt($("#HscrParameter1").val())*Math.PI/180/NoOfTrees,ii);    			
		}
	}
}

function DrawTree3(N,x,y,a,branchRadius){
	var ScrXOffset,ScrYOffset;    
	var BendAngle,BranchAngle,BranchRatio,cx,cy;
	ScrXOffset=appletWidth/2;
	ScrYOffset=BottomPanelTop;
	BendAngle=parseInt($("#HscrParameter1").val())*Math.PI/180;
	BranchAngle=parseInt($("#HscrParameter2").val())*Math.PI/180;
	BranchRatio=0.65;
	cx=x+Math.cos(a)*branchRadius;
	cy=y-Math.sin(a)*branchRadius;
	if($("#colorise").prop("checked")){
		//if (N>HscrMinimumLength.getValue()){
		if(N>0){
			cntx.strokeStyle=WoodColor;
		}
		else{
			cntx.strokeStyle=LeavesColor;
		}
	}
	cntx.beginPath();
	cntx.moveTo(parseInt(ScrXOffset+x),parseInt(ScrYOffset+y));
	cntx.lineTo(parseInt(ScrXOffset+cx),parseInt(ScrYOffset+cy));
	cntx.stroke();

	if(N>0){
		DrawTree3(N-1,cx,cy,a+BendAngle-BranchAngle,branchRadius*BranchRatio);
   		DrawTree3(N-1,cx,cy,a+BendAngle+BranchAngle,branchRadius*BranchRatio);
   		DrawTree3(N-1,cx,cy,a+BendAngle,branchRadius*(1-BranchRatio));
	}
}

function DrawSierpinski(Size,x,y){
	  var newX=[0,0,0],newY=[0,0,0],NewSize;
	  var TR1X=[0,0,0],TR1Y=[0,0,0];
	  var TR2X=[0,0,0],TR2Y=[0,0,0];
	  var TR3X=[0,0,0],TR3Y=[0,0,0];
	  NewSize=Size/2;
	  if(NewSize>Math.pow(2,parseInt($("#HscrParameter2").val()))){
	    newX[0]=Math.min(x[0],Math.min(x[1],x[2]))+Size/2;
	    newX[1]=newX[0]-Size/4;
	    newX[2]=newX[0]+Size/4;
	    
	    newY[1]=parseInt(Math.min(y[0],Math.min(y[1],y[2]))+Size*Math.sin(Math.PI/3)/2);
	    newY[2]=newY[1];
	    newY[0]=parseInt(newY[1]+Size*Math.sin(Math.PI/3)/2);

        cntx.beginPath();
        cntx.moveTo(newX[2],newY[2]);
        for(i=0;i<3;i++){
            cntx.lineTo(newX[i],newY[i]);
        }
        cntx.closePath();
        cntx.fill();

	    TR1X[0]=newX[0];
	    TR1Y[0]=y[0];
	    TR1X[1]=TR1X[0]-NewSize/2;
	    TR1Y[1]=parseInt(TR1Y[0]+NewSize*Math.sin(Math.PI/6)/2);
	    TR1X[2]=TR1X[0]+NewSize/2;
	    TR1Y[2]=TR1Y[1];
	    DrawSierpinski(NewSize,TR1X,TR1Y);
	  
	    TR2X[0]=newX[1];
	    TR2Y[0]=newY[1];
	    TR2X[1]=newX[1]-NewSize/2;
	    TR2Y[1]=parseInt(TR2Y[0]+NewSize*Math.sin(Math.PI/6)/2);
	    TR2X[2]=TR2X[0]+NewSize/2;
	    TR2Y[2]=TR2Y[1];
	    DrawSierpinski(NewSize,TR2X,TR2Y);
	  
	    TR3X[0]=newX[2];
	    TR3Y[0]=newY[2];
	    TR3X[1]=newX[2]-NewSize/2;
	    TR3Y[1]=parseInt(TR3Y[0]+NewSize*Math.sin(Math.PI/6)/2);
	    TR3X[2]=TR3X[0]+NewSize/2;
	    TR3Y[2]=TR3Y[1];
	    DrawSierpinski(NewSize,TR3X,TR3Y);
	  }    	
}

function RecursiveCircles(R,Xc,Yc,ColorSelector){
	var X2c,Y2c,NewR,NewColorSelector;
	if(R>Math.pow(2,parseInt($("#HscrParameter2").val()))){
		cntx.beginPath();
		cntx.arc(Xc,Yc,R,0,2*Math.PI);
    	if($("#colorise").prop("checked")){
    		if(ColorSelector==0){        		
    			cntx.fillStyle="rgb(255,0,0)";
    		}        	
    		else{
    			cntx.fillStyle="rgb(255,255,255)";
    		}    		
    		cntx.fill();
    	}
    	else{
    		cntx.stroke();
    	}
		NewColorSelector=1-ColorSelector;
		NewR=R/2;
		X2c=Xc-NewR;
		Y2c=Yc;
		RecursiveCircles(NewR,X2c,Y2c,NewColorSelector);
		X2c=Xc+NewR;
		Y2c=Yc;
		RecursiveCircles(NewR,X2c,Y2c,NewColorSelector);
		X2c=Xc;
		Y2c=Yc-NewR;
		RecursiveCircles(NewR,X2c,Y2c,NewColorSelector);
		X2c=Xc;
		Y2c=Yc+NewR;
		RecursiveCircles(NewR,X2c,Y2c,NewColorSelector);
	}
}

function rangeValueChanged(rangeID){
    if(rangeID=="HscrParameter1"){
        if(IntroStep==Tree1){
            $("#lblParameter1").html(10*parseFloat($("#HscrParameter1").val())+"%");
        }
        else if(IntroStep==Tree2 || IntroStep==Tree3){
            $("#lblParameter1").html("θ="+parseInt($("#HscrParameter1").val()));
            if($("#chkLockAngles").prop("checked")){
                $("#HscrParameter2").val(parseInt($("#HscrParameter1").val()));
                $("#lblParameter2").html("φ="+parseInt($("#HscrParameter2").val()));
            }
        }
        else if(IntroStep==Triangle){
            $("#lblParameter1").html("Πλευρά="+parseInt($("#HscrParameter1").val())*100);
        }
        else if(IntroStep==Square){
            $("#lblParameter1").html("Πλευρά="+100*parseInt($("#HscrParameter1").val()));
        }
        else if(IntroStep==Circles){
            $("#lblParameter1").html("Ακτίνα="+10*parseInt($("#HscrParameter1").val()));
        }
    }
    else if(rangeID=="HscrParameter2"){
      $("#lblParameter2").html("φ="+parseInt($("#HscrParameter2").val()));
      if($("#chkLockAngles").prop("checked")){
          $("#HscrParameter1").val(parseInt($("#HscrParameter2").val()));
          $("#lblParameter1").html("θ="+parseInt($("#HscrParameter1").val()));
      }
    }
    else if(rangeID=="HscrLength"){
        if(IntroStep==Tree2){
            $("#HscrMinimumLength").attr("max",Math.max(parseInt($("#HscrLength").val())-2,2));
        }
    }
    initialiseDrawingParams();
}

function HideControls(){
    $("#HscrParameter1").hide();
    $("#lblParameter1").hide();
    $("#HscrParameter2").hide();
    $("#lblParameter2").hide();
    $("#HscrLength").hide();
    $("#HscrMinimumLength").hide();
    $("#HscrDirection").hide();
    $("#colorise").hide();
    $("#lblColorise").hide();
    $("#chkLockAngles").hide();
    $("#lblLockAngles").hide();
    $("#btnRestart").hide();
    $("#btnNewGame").hide();
    $("#HscrParameter1").attr("min",0);
    $("#HscrParameter2").attr("min",0);
    if(IntroStep==Tree1){
        $("#chkShowCode").hide();
        $("#lblShowCode").hide();
        $("#btnRestart").show();
        $("#btnNewGame").show();
        $("#HscrParameter1").show();
        $("#HscrParameter1").attr("min",1);
        $("#HscrParameter1").attr("max",8);
        $("#HscrParameter1").val(0);
        $("#lblParameter1").show();
        $("#colorise").show();
        $("#lblParameter1").html("10%");
        $("#lblParameter1").show();
    }
    else if(IntroStep==Tree2){
        $("#chkShowCode").hide();
        $("#lblShowCode").hide();
        $("#btnRestart").show();
        $("#lblColorise").text("Χρωματισμός");
        $("#colorise").show();
        $("#lblColorise").show();
        $("#HscrParameter1").show();
        $("#chkLockAngles").show();
        $("#lblLockAngles").text("Ταυτόχρονα");
        $("#lblLockAngles").show();
        $("#HscrParameter2").show();
        $("#lblParameter1").show();
        $("#lblParameter2").show();
        $("#HscrParameter1").attr("max",360);
        $("#HscrParameter2").attr("max",360);
        $("#HscrParameter1").val(30);
        $("#HscrParameter2").val(37);
        $("#lblParameter1").text("θ="+parseInt($("#HscrParameter1").val()));
        $("#lblParameter2").text("φ="+parseInt($("#HscrParameter2").val()));
        $("#HscrLength").val(10);
        $("#HscrLength").show();
        $("#HscrMinimumLength").show();
        $("#HscrDirection").val(90);
        $("#HscrDirection").show();
    }
    else if(IntroStep==Tree3){
        $("#HscrMinimumLength").attr("max",8);
        $("#chkShowCode").hide();
        $("#lblShowCode").hide();
        $("#btnRestart").show();
        $("#lblColorise").text("Χρωματισμός");
        $("#lblColorise").show();
        $("#colorise").show();
        $("#lblColorise").val(13);
        $("#chkLockAngles").show();
        $("#lblLockAngles").text("Ταυτόχρονα");
        $("#lblLockAngles").show();
        $("#HscrParameter1").val(15);
        $("#HscrParameter2").val(37);
        $("#lblParameter1").text("θ="+parseInt($("#HscrParameter1").val()));
        $("#lblParameter2").text("φ="+parseInt($("#HscrParameter2").val()));
        $("#lblParameter1").show();
        $("#lblParameter2").show();
        $("#HscrParameter1").show();
        $("#HscrParameter2").show();
        $("#HscrLength").show();
        $("#HscrMinimumLength").show();
        $("#HscrDirection").val(90);
        $("#HscrDirection").show();
    }
    else if(IntroStep==Forest){
        $("#chkShowCode").hide();
        $("#lblShowCode").hide();
        $("#btnRestart").hide();
        $("#HscrDirection").val(90);
        $("#HscrMinimumLength").val(1);
        $("#HscrLength").val(10);
        $("#HscrParameter1").val(15);
        $("#HscrParameter2").val(37);
        $("#btnNewGame").show();
    }
    else if(IntroStep==Triangle){
        $("#chkShowCode").show();
        $("#lblShowCode").show();
        $("#btnRestart").show();
        $("#lblParameter1").show();
        $("#lblParameter1").text("Πλευρά=100");
        $("#HscrParameter1").attr("min",1);
        $("#HscrParameter1").val(1);
        $("#HscrParameter1").attr("max",9);
        $("#HscrParameter2").attr("min",2);
        $("#HscrParameter2").val(2);
        $("#HscrParameter2").attr("max",9);
        $("#HscrParameter1").show();
        $("#HscrParameter2").show();
    }
    else if(IntroStep==Square){
        $("#chkShowCode").show();
        $("#lblShowCode").show();
        $("#btnRestart").show();
        $("#HscrParameter1").attr("min",1);
        $("#HscrParameter1").val(1);
        $("#HscrParameter1").attr("max",9);
        $("#HscrParameter2").attr("min",2);
        $("#HscrParameter2").val(2);
        $("#HscrParameter2").attr("max",7);
        $("#HscrParameter1").show();
        $("#HscrParameter2").show();
        $("#lblParameter1").text("Πλευρά="+100*parseInt($("#HscrParameter1").val()));
        $("#lblParameter1").show();
    }
    else if(IntroStep==Circles){
        $("#chkShowCode").show();
        $("#lblShowCode").show();
        $("#colorise").prop("checked",false);
        $("#btnRestart").show();
        $("#lblColorise").text("Συμπαγείς");
        $("#lblColorise").show();
        $("#colorise").show();
        $("#HscrParameter1").attr("min",1);
        $("#HscrParameter1").attr("max",21);
        $("#HscrParameter1").val(18);
        $("#HscrParameter1").show();
        $("#HscrParameter2").attr("min",1);
        $("#HscrParameter2").attr("max",7);
        $("#HscrParameter1").val(15);
        $("#HscrParameter2").show();
        $("#lblParameter1").text("Ακτίνα="+10*parseInt($("#HscrParameter1").val()));
        $("#lblParameter1").show();
    }
}

function DrawGasket(x,y,Side){
    var subSide;
    subSide=Side/3; //length of sub-squares    
    cntx.fillRect(x+subSide,y+subSide,subSide-1,subSide-1);
    if(subSide>=Math.pow(3,parseInt($("#HscrParameter2").val()))){
        DrawGasket(x,y,subSide);
        DrawGasket(x+subSide,y,subSide);
        DrawGasket(x+2*subSide,y,subSide);
        DrawGasket(x,y+subSide,subSide);
        DrawGasket(x+2*subSide,y+subSide,subSide);
        DrawGasket(x,y+2*subSide,subSide);
        DrawGasket(x+subSide,y+2*subSide,subSide);
        DrawGasket(x+2*subSide,y+2*subSide,subSide);
    }
}

function DrawProgram(){
    var initX=10,initY=TopPanelHeight+10*Border;
    if(IntroStep==Tree1){
        //do nothing
    }
    else if(IntroStep==Tree2){
        //do nothing
    }
    else if(IntroStep==Tree3){
        //do nothing
    }
    else if(IntroStep==Forest){
        //do nothing
    }
    else if(IntroStep==Triangle){
        SierpinskiProgram(initX,initY);         
    }
    else if(IntroStep==Square){
        SquaresProgram(initX,initY);
    }
    else if(IntroStep==Circles){
        CirclesProgram(initX,initY);
    }
}

function SquaresProgram(Xinit,Yinit){
    var Command;
    var Xcommand=Xinit,dX=15,CurrentX;
    var Ycommand=Yinit,dY=15;
    Command="ΤΕΤΡΑΓΩΝΟ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="Χ, Y, α";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    Xcommand=Xcommand+dX;
    Ycommand=Ycommand+dY;
    Command="αΝέο ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,ParameterColor);
    Command="<--";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command=" α";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" / ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="3";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);

    Ycommand=Ycommand+dY;
    Command="ΣχεδίασεΤετράγωνο(";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command="X";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, Υ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, αΝέο, αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    
    
    Ycommand=Ycommand+dY;
    Command="ΑΝ ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command="αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" > ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command=""+parseInt(Math.pow(3,parseInt($("#HscrParameter2").val())));
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" ΤΟΤΕ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Xcommand=Xcommand+dX;

    //1o
    Ycommand=Ycommand+dY;
    Command="ΤΕΤΡΑΓΩΝΟ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="X, Y, αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    //2o
    Ycommand=Ycommand+dY;
    Command="ΤΕΤΡΑΓΩΝΟ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="X";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, Y, αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    //3o
    Ycommand=Ycommand+dY;
    Command="ΤΕΤΡΑΓΩΝΟ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="X";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="2";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" * ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, Y, αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    //4o
    Ycommand=Ycommand+dY;
    Command="ΤΕΤΡΑΓΩΝΟ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="X, Y";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    //5o
    Ycommand=Ycommand+dY;
    Command="ΤΕΤΡΑΓΩΝΟ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="X";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="2";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" * ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, Y";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    //6o
    Ycommand=Ycommand+dY;
    Command="ΤΕΤΡΑΓΩΝΟ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="X, Y";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="2";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" * ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    //7o
    Ycommand=Ycommand+dY;
    Command="ΤΕΤΡΑΓΩΝΟ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="X";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, Y";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="2";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" * ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    //8o
    Ycommand=Ycommand+dY;
    Command="ΤΕΤΡΑΓΩΝΟ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="X";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="2";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" * ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, Y";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="2";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" * ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="αΝέο, αΝέο";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    Xcommand=Xcommand-dX;
    Ycommand=Ycommand+dY;
    PrintText("ΤΕΛΟΣ_ΑΝ",Xcommand,Ycommand,CommandColor);
    Xcommand=Xcommand-dX;
    Ycommand=Ycommand+dY;
    PrintText("ΤΕΛΟΣ_ΤΕΤΡΑΓΩΝΟ",Xcommand,Ycommand,CommandColor);
}

function SierpinskiProgram(Xinit,Yinit){
    var Command;
    var Xcommand=Xinit,dX=15,CurrentX;
    var Ycommand=Yinit,dY=15;
    Command="SIERPINSKI";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="Α, Β, Γ, Πλευρά";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Xcommand=Xcommand+dX;
    Ycommand=Ycommand+dY;
    Command="ΑΝ ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command="Πλευρά";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" > ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command=""+parseInt(Math.pow(2,parseInt($("#HscrParameter2").val())));
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" ΤΟΤΕ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    Xcommand=Xcommand+dX;
    Ycommand=Ycommand+dY;
    Command="ΧΡΩΜΑ ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command=" Λευκό";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);

    Ycommand=Ycommand+dY;
    Command="ΣχεδίασεΤρίγωνο(";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command="Α, Β, Γ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Ycommand=Ycommand+dY;
    Command="ΝέαΠλευρά ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,ParameterColor);
    Command="<--";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command=" Πλευρά";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" / ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="2";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Ycommand=Ycommand+dY;
    Command="ΥΠΟΛΟΓΙΣΕ ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command="Α1,Β1,Γ1 του πάνω τριγώνου";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Ycommand=Ycommand+dY;
    Command="ΥΠΟΛΟΓΙΣΕ ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command="Α2,Β2,Γ2 του αριστερού τριγώνου";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Ycommand=Ycommand+dY;
    Command="ΥΠΟΛΟΓΙΣΕ ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command="Α3,Β3,Γ3 του δεξιού τριγώνου";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Ycommand=Ycommand+dY;
    Command="SIERPINSKI";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="Α1, Β1, Γ1, ΝέαΠλευρά";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Ycommand=Ycommand+dY;
    Command="SIERPINSKI";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="Α2, Β2, Γ2, ΝέαΠλευρά";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Ycommand=Ycommand+dY;
    Command="SIERPINSKI";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="Α3, Β3, Γ3, ΝέαΠλευρά";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Xcommand=Xcommand-dX;
    Ycommand=Ycommand+dY;
    PrintText("ΤΕΛΟΣ_ΑΝ",Xcommand,Ycommand,CommandColor);
    Xcommand=Xcommand-dX;
    Ycommand=Ycommand+dY;
    PrintText("ΤΕΛΟΣ_SIERPINSKI",Xcommand,Ycommand,CommandColor);
}

function CirclesProgram(Xinit,Yinit){
    var Command;
    var Xcommand=Xinit,dX=15,CurrentX;
    var Ycommand=Yinit,dY=15;
    Command="ΚΥΚΛΟΣ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);     
    Command="ΚέντροΧ, ΚέντροΥ, Ακτίνα, Εναλλαγή";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

    Xcommand=Xcommand+dX;
    Ycommand=Ycommand+dY;
    Command="ΑΝ ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command="Ακτίνα";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" > ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command=""+parseInt(Math.pow(2,parseInt($("#HscrParameter2").val())));
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" ΤΟΤΕ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Xcommand=Xcommand+dX;
    if($("#colorise").prop("checked")){               
        Ycommand=Ycommand+dY;
        Command="AN ";
        CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
        Command="Εναλλαγή";
        CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
        Command=" = ";
        CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
        Command="0";
        CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
        Command=" ΤΟΤΕ";
        CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);

        Xcommand=Xcommand+dX;
        Ycommand=Ycommand+dY;
        Command="ΧΡΩΜΑ ";
        CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
        Command="Κόκκινο";
        CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
        
        Xcommand=Xcommand-dX;
        Ycommand=Ycommand+dY;
        Command="ΑΛΛΙΩΣ";
        CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
        
        
        Xcommand=Xcommand+dX;
        Ycommand=Ycommand+dY;
        Command="ΧΡΩΜΑ ";
        CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
        Command="Λευκό";
        CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
        
        Xcommand=Xcommand-dX;
        Ycommand=Ycommand+dY;
        Command="ΤΕΛΟΣ_ΑΝ";
        CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);

        Ycommand=Ycommand+dY;
        Command="ΓΕΜΙΣΜΑ ";
        CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
        Command="ΝΑΙ";
        CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    }
    else{
        Ycommand=Ycommand+dY;
        Command="ΓΕΜΙΣΜΑ ";
        CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
        Command="ΟΧΙ";
        CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    }
    Ycommand=Ycommand+dY;
    Command="ΣΧΕΔΙΑΣΕ_ΚΥΚΛΟ(";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    Command="ΚέντροΧ, ΚέντροΥ, Ακτίνα";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    
    Ycommand=Ycommand+dY;
    Command="Εναλλαγή";
    CurrentX=PrintText(Command,Xcommand,Ycommand,ParameterColor);
    Command=" = ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="1";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    Command=" - ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="Εναλλαγή ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    
    
    Ycommand=Ycommand+dY;
    Command="ΝεαΑκτίνα";
    CurrentX=PrintText(Command,Xcommand,Ycommand,ParameterColor);
    Command=" = ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="Ακτίνα";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" / ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="2";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ConstantColor);
    
    Ycommand=Ycommand+dY;
    Command="ΝέοΚέντροΧ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,ParameterColor);
    Command=" = ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΚέντροΧ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" - ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΝέαΑκτίνα";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    
    
    Ycommand=Ycommand+dY;
    Command="ΚΥΚΛΟΣ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΝέαΑκτίνα, ΝέοΚέντροΧ, ΚέντροΥ, Εναλλαγή";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    
    Ycommand=Ycommand+dY;
    Command="ΝέοΚέντροΧ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,ParameterColor);
    Command=" = ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΚέντροΧ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΝέαΑκτίνα";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    
    Ycommand=Ycommand+dY;
    Command="ΚΥΚΛΟΣ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΝέαΑκτίνα, ΝέοΚέντροΧ, ΚέντροΥ, Εναλλαγή";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    
    Ycommand=Ycommand+dY;
    Command="ΝέοΚέντροY";
    CurrentX=PrintText(Command,Xcommand,Ycommand,ParameterColor);
    Command=" = ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΚέντροY";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" - ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΝέαΑκτίνα";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);

    Ycommand=Ycommand+dY;
    Command="ΚΥΚΛΟΣ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΝέαΑκτίνα, ΚέντροΧ, ΝέοΚέντροΥ, Εναλλαγή";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    
    Ycommand=Ycommand+dY;
    Command="ΝέοΚέντροY";
    CurrentX=PrintText(Command,Xcommand,Ycommand,ParameterColor);
    Command=" = ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΚέντροY";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=" + ";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΝέαΑκτίνα";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    
    Ycommand=Ycommand+dY;
    Command="ΚΥΚΛΟΣ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,RecursiveCommandColor);
    Command="(";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    Command="ΝέαΑκτίνα, ΚέντροΧ, ΝέοΚέντροΥ, Εναλλαγή";
    CurrentX=PrintText(Command,CurrentX,Ycommand,ParameterColor);
    Command=")";
    CurrentX=PrintText(Command,CurrentX,Ycommand,CommandColor);
    
    Xcommand=Xcommand-dX;
    Ycommand=Ycommand+dY;
    Command="ΤΕΛΟΣ_ΑΝ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
    
    Xcommand=Xcommand-dX;
    Ycommand=Ycommand+dY;
    Command="ΤΕΛΟΣ_ΚΥΚΛΟΣ";
    CurrentX=PrintText(Command,Xcommand,Ycommand,CommandColor);
}

function PrintText(txt,Xcommand,Ycommand,clr){
    var fontWeight="";
    if(clr==CommandColor){
        fontWeight="bold";
    }
    else if(clr==RecursiveCommandColor){
        fontWeight="bold";
    }
    else if(clr==ParameterColor){
        fontWeight="normal";
    }
    else if(clr==ConstantColor){
        fontWeight="bold";
    }
    cnvsWrite(clr,fontWeight+" 14","Dialog",Xcommand,Ycommand,txt,fontWeight);
    return Xcommand+cntx.measureText(txt).width+1;
}